public class Tester {
	boolean [] G;
	public void start() {
		test(4);
 		}

public void test (int n) {
	for (int i=0; i<Math.pow(2,n); i++) {
		boolean[] G1 = new boolean[n+1];
		initialise (G1, i);
		System.out.print("i:  "+i+"  ");
		display (G1);
		System.out.println();
		for (int j=0; j<Math.pow(2,n); j++) {
			boolean[] G2 = new boolean[n+1];
			initialise (G2,j);
			System.out.print("      j:  "+j+"  ");
			display (G2);
			boolean[] S = new boolean[n+1];
			add(n,G1,G2,S);
			int s = getBinaryValue(S);
			System.out.print("    s:   "+s+"  ");
			display (S);
			System.out.println();
			if (((i+j)<Math.pow(2,n))&(s != ((i+j)%Math.pow(2,n)))) displayError(G1,G2,S);
			}
		}
	}


public void initialise (boolean[]G,int k){ // Gray with G[0] parity
	int n = G.length -1;
	// find binary bits B for k
	boolean [] B = new boolean[n+1]; // binary, no parity B[n] == 0
	B[n] = false;
	for (int i = 0; i<n; i++) {
		B[i] = (k%2 == 1);
		k = k/2;
		}
	// convert B to G
	boolean p = false; // parity
	for (int i = n; i>0; i--) {
		G[i] = B[i]^B[i-1];
		p = p ^ G[i];
		}
	G[0] = p;
	}

public int getBinaryValue (boolean [] G){ // Gray with parity (ignored)
	int n = G.length - 1;
	int pow2 = (int) Math.pow(2,n-1);
	int val = 0;
	boolean b = false;
	for (int i = n; i>0; i--) {
		b = b ^ G[i];
		if (b) val = val + pow2;
		pow2 = pow2/2;
		}
	return val;
	}

public void displayError (boolean[]G1, boolean[]G2, boolean[]S){
	System.out.print("**** G1:  ");
	display(G1);
	System.out.println();
	System.out.print("G2:  ");
	display(G2);
	System.out.println();
	System.out.print("S:  ");
	display(S);
	System.out.println();
	}


public void display(boolean [] G){
	for (int i = G.length-1; i>=0; i--) {
		if (G[i]) System.out.print(1);
		else System.out.print(0);
		}
	}



/* ALGORITHM A5: SERIAL ADDITION OF GRAY CODE WORDS */
public void add (int n, 					// width of words
				boolean[] A, boolean[] B, 	// addends, low order bit parity
				boolean[] S) {				// result, low order bit parity

	boolean E, F; 	// running carries
	boolean ET, FT; // temporary carries, not needed if loop statements parallel
	E = A[0]; F = B[0];
	S[0] = E ^ F;
	for (int i=1; i<=n; i++) {
		S[i] = (E & F) ^A[i] ^ B[i];
		ET	 = (E & (!F)) ^ A[i];
		FT	 = ((!E) & F) ^ B[i];
		E = ET;
		F = FT;
		}
	// at this point, if E and F are not 0, there is an overflow
	// and the value represented by S is the 1s-complement of the sum
	}

}




